' **********************************************
' *** ***
' *** Reaktiv-Tiny mit Watchdog-Abschaltung ***
' *** ***
' **********************************************

$regfile = "ATtiny13.DAT"
$crystal = 16000 			  'Frequenz des internen Oszillators

Config Portb = &B00011000 		 'Pinb.3 und .4 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = &B11100111 			'Pullups zuschalten, auer fr Pinb.3 und .4
Stop Adc 				  'A/D-Wandler abschalten, um Strom zu sparen
Stop Ac 				   'Analog-Komparator abschalten, um Strom zu sparen

Wdtcr = &B11010011 			'Watchdog definieren: 0.125 Sekunden, Interrupt auslsen, kein Reset
Enable Interrupts 			 'Interrupts freigeben

Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim Led_ladezustand As Bit
Dim Hell As Bit
Dim Hell_2 As Byte

Do
	Gosub Led_abfrage
	If Led_ladezustand = 0 Then 
		Hell = 1 		  'Bei Licht Merker setzen
	End If
	If Hell = 1 And B < 255 Then 
		B = B + 1 		 'Wenn Merker gesetzt wurde, Zhler fr Lichtdauer erhhen (bis max. 255)
	End If
	If Led_ladezustand = 1 And Hell = 1 And B < 30 Then 'Wenn es wieder dunkel ist und der Lichtimpuls nur kurz war
		Hell_2 = 0 		'zweiten Hell-Merker setzen
		For C = 0 To 5 	    'und 5 mal afragen
			Gosub Led_abfrage
			If Led_ladezustand = 0 Then 
				Hell_2 = Hell_2 + 1 'ob es auch wieder dunkel ist
			End If
		Next C
		If Hell_2 = 0 Then 
			Gosub Blinken      'erst dann blinken
		End If
		Hell = 0
		B = 0
	End If
	If Led_ladezustand = 1 Then        'Bei Dunkelheit Merker und Zhler fr Lichtdauer lschen
		Hell = 0 		  'damit sich das Programm nicht aufhngt
		B = 0
	End If
Loop

Led_abfrage:
	Portb.4 = 1 		       'Portb.4 auf +Ub schalten, um die LED zu 'laden'
	Waitus 1 			  'Ladezeit, kann ggf. noch verkleinert werden
	Config Portb.4 = Input 	    'Portb.4 nun zwecks Abfrage der LED-Ladung auf 'Eingang' schalten
	Portb.4 = 0 		       'Pullup abschalten, sonst geht's nicht!
	Reset Watchdog 		    'Watchdog zurcksetzen dass Controller rechtzeizig aufwacht
	Powerdown 			 'Whrend des Entladens den Controller Schlafen schicken
	Led_ladezustand = Pinb.4 	  'Ladezustand einlesen: '1' -> dunkel, '0' -> hell
	Config Portb.4 = Output 	   'Portb.4 wieder auf Ausgang schalten
Return

Blinken:
	For A = 1 To 10
		Portb.3 = 1
		Reset Watchdog
		Powerdown
		Portb.3 = 0
		Reset Watchdog
		Powerdown
	Next A
Return

End